package jp.co.thinkit.equinox.hello.service.rss;

import java.text.SimpleDateFormat;
import java.util.Date;

import jp.co.thinkit.equinox.hello.ui.INotificationMessage;

public class RssNortificationMessage implements INotificationMessage ,Comparable<RssNortificationMessage>{

	private String message;
	
	private String link;
	
	private Date update;
	
	public RssNortificationMessage(String message,String link, Date update){
		this.message = message;
		this.link = link;
		this.update = update;
	}

	public String getTitle() {
		if(message != null && message.length() > 23){
			message = message.substring(0, 20);
			return message + "...";
		}
		return message;
	}


	public String getLink() {
		return link;
	}
	
	public Date getUpdate() {
		return update;
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("[Update] : " + SimpleDateFormat.getDateTimeInstance().format(update) + "\n");
		builder.append("[Message] : " + getTitle() + "\n");
		builder.append("[Link] : " + getLink() + "\n");
		return builder.toString();
	}

	public int compareTo(RssNortificationMessage target) {
		Date lhs = this.getUpdate();
		Date rhs = target.getUpdate();
		return lhs.compareTo(rhs);
	}

}
