package jp.co.thinkit.equinox.hello.service.rss;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.List;

import jp.co.thinkit.equinox.hello.ui.INotificationMessage;
import jp.co.thinkit.equinox.hello.ui.INotificationService;

import com.sun.syndication.feed.synd.SyndEntry;
import com.sun.syndication.feed.synd.SyndFeed;
import com.sun.syndication.io.FeedException;
import com.sun.syndication.io.SyndFeedInput;
import com.sun.syndication.io.XmlReader;

public class RssNortificationService implements INotificationService {

	private static Date lastUpdate;
	static{
		lastUpdate = new Date();
		lastUpdate.setTime(0L);
	}

	public List<? extends INotificationMessage> getContents() {
		List<RssNortificationMessage> contents = new ArrayList<RssNortificationMessage>();
        SyndFeedInput input = new SyndFeedInput();
        List<String> urls = new ArrayList<String>();
        urls.add("http://www.thinkit.co.jp/rss.xml");
        // TRICHORD Blog
        //urls.add("http://trichord.change-vision.com/blog/atom.xml");
        for(String url : urls){
            URL feedUrl = null;
    		try {
    			feedUrl = new URL(url);
    		} catch (MalformedURLException e) {
    			e.printStackTrace();
    		}
    		List<?> entries = null;
    		try {
    			SyndFeed feed = input.build(new XmlReader(feedUrl));
    			entries = feed.getEntries();
    			for(Object obj : entries){
    				SyndEntry entry = (SyndEntry) obj;
    				if(entry.getPublishedDate().compareTo(lastUpdate) > 0){
    					RssNortificationMessage message = new RssNortificationMessage(entry.getTitle(),entry.getLink(),entry.getPublishedDate());
    					contents.add(message);					
    				}
    			}
    		} catch (IllegalArgumentException e) {
    			e.printStackTrace();
    		} catch (FeedException e) {
    			e.printStackTrace();
    		} catch (IOException e) {
    			e.printStackTrace();
    		}        	
        }
		if(contents.isEmpty()) return contents;
		Collections.sort(contents, new Comparator<RssNortificationMessage>(){
			public int compare(RssNortificationMessage lhs,
					RssNortificationMessage rhs) {
				return rhs.compareTo(lhs);
			}
		});
		//lastUpdate = contents.get(0).getUpdate();
		if(contents.size() > 10){
			contents = contents.subList(0, 10);			
		}
        return contents;
	}

}
